RSAFunction Class Reference

RSA trapdoor function using the public key. More...

`#include <rsa.h>`

Inheritance diagram for RSAFunction:

## Public Member Functions

void | Initialize (const Integer &n, const Integer &e)
| Initialize a RSA public key.
OID | GetAlgorithmID () const
| Retrieves the OID of the algorithm.
void | BERDecodePublicKey (BufferedTransformation &bt, bool parametersPresent, size_t size)
| Decode subjectPublicKey part of subjectPublicKeyInfo.
void | DEREncodePublicKey (BufferedTransformation &bt) const
| Encode subjectPublicKey part of subjectPublicKeyInfo.
bool | Validate (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors.
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| Get a named value.
void | AssignFrom (const NameValuePairs &source)
| Assign values to this object.
Integer | ApplyFunction (const Integer &x) const
| Applies the trapdoor.
Integer | PreimageBound () const
| Returns the maximum size of a message before the trapdoor function is applied.
Integer | ImageBound () const
| Returns the maximum size of a representation after the trapdoor function is applied.
const Integer & | GetModulus () const
const Integer & | GetPublicExponent () const
void | SetModulus (const Integer &n)
void | SetPublicExponent (const Integer &e)
Public Member Functions inherited from TrapdoorFunction
Integer | ApplyRandomizedFunction (RandomNumberGenerator &rng, const Integer &x) const
| Applies the trapdoor function.
bool | IsRandomized () const
| Determines if the encryption algorithm is randomized.
Public Member Functions inherited from TrapdoorFunctionBounds
virtual Integer | MaxPreimage () const
| Returns the maximum size of a message before the trapdoor function is applied bound to a public key.
virtual Integer | MaxImage () const
| Returns the maximum size of a representation after the trapdoor function is applied bound to a public key.
Public Member Functions inherited from X509PublicKey
void | BERDecode (BufferedTransformation &bt)
| Decode this object from a BufferedTransformation.
void | DEREncode (BufferedTransformation &bt) const
| Encode this object into a BufferedTransformation.
virtual bool | BERDecodeAlgorithmParameters (BufferedTransformation &bt)
| Decode algorithm parameters.
virtual bool | DEREncodeAlgorithmParameters (BufferedTransformation &bt) const
| Encode algorithm parameters.
Public Member Functions inherited from ASN1CryptoMaterial< PublicKey >
void | Save (BufferedTransformation &bt) const
| DER encode ASN.1 object.
void | Load (BufferedTransformation &bt)
| BER decode ASN.1 object.
Public Member Functions inherited from ASN1Object
virtual void | BEREncode (BufferedTransformation &bt) const
| Encode this object into a BufferedTransformation.
Public Member Functions inherited from CryptoMaterial
virtual void | ThrowIfInvalid (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors.
virtual bool | SupportsPrecomputation () const
| Determines whether the object supports precomputation.
virtual void | Precompute (unsigned int precomputationStorage)
| Perform precomputation.
virtual void | LoadPrecomputation (BufferedTransformation &storedPrecomputation)
| Retrieve previously saved precomputation.
virtual void | SavePrecomputation (BufferedTransformation &storedPrecomputation) const
| Save precomputation for later use.
void | DoQuickSanityCheck () const
| Perform a quick sanity check.
Public Member Functions inherited from NameValuePairs
template<class T >
bool | GetThisObject (T &object) const
| Get a copy of this object or subobject.
template<class T >
bool | GetThisPointer (T *&ptr) const
| Get a pointer to this object.
template<class T >
bool | GetValue (const char *name, T &value) const
| Get a named value.
template<class T >
T | GetValueWithDefault (const char *name, T defaultValue) const
| Get a named value.
CRYPTOPP_DLL std::string | GetValueNames () const
| Get a list of value names that can be retrieved.
CRYPTOPP_DLL bool | GetIntValue (const char *name, int &value) const
| Get a named value with type int.
CRYPTOPP_DLL int | GetIntValueWithDefault (const char *name, int defaultValue) const
| Get a named value with type int, with default.
CRYPTOPP_DLL bool | GetWord64Value (const char *name, word64 &value) const
| Get a named value with type word64.
CRYPTOPP_DLL word64 | GetWord64ValueWithDefault (const char *name, word64 defaultValue) const
| Get a named value with type word64, with default.
template<class T >
void | GetRequiredParameter (const char *className, const char *name, T &value) const
| Retrieves a required name/value pair.
CRYPTOPP_DLL void | GetRequiredIntParameter (const char *className, const char *name, int &value) const
| Retrieves a required name/value pair.

## Additional Inherited Members

Static Public Member Functions inherited from NameValuePairs
static CRYPTOPP_DLL void | ThrowIfTypeMismatch (const char *name, const std::type_info &stored, const std::type_info &retrieving)
| Ensures an expected name and type is present.

## Detailed Description

RSA trapdoor function using the public key.

Since
  Crypto++ 1.0

Definition at line 23 of file rsa.h.

## Member Function Documentation

## Initialize()

void RSAFunction::Initialize | ( | const Integer & | n,
|  | const Integer & | e
| ) |  |

inline

Initialize a RSA public key.

Parameters

  n | the modulus
  e | the public exponent

Definition at line 31 of file rsa.h.

## GetAlgorithmID()

OID RSAFunction::GetAlgorithmID | ( |  | ) | const

virtual

Retrieves the OID of the algorithm.

Returns
  OID of the algorithm

Implements X509PublicKey.

## BERDecodePublicKey()

void RSAFunction::BERDecodePublicKey | ( | BufferedTransformation & | bt,
|  | bool | parametersPresent,
|  | size_t | size
| ) |  |

virtual

Decode subjectPublicKey part of subjectPublicKeyInfo.

Parameters

  bt | BufferedTransformation object
  parametersPresent | flag indicating if algorithm parameters are present
  size | number of octets to read for the parameters, in bytes

BERDecodePublicKey() the decodes subjectPublicKey part of subjectPublicKeyInfo, without the BIT STRING header.

When `parametersPresent = true` then BERDecodePublicKey() calls BERDecodeAlgorithmParameters() to parse algorithm parameters.

See also
  BERDecodeAlgorithmParameters

Implements X509PublicKey.

## DEREncodePublicKey()

void RSAFunction::DEREncodePublicKey | ( | BufferedTransformation & | bt | ) | const

virtual

Encode subjectPublicKey part of subjectPublicKeyInfo.

Parameters

  bt | BufferedTransformation object

DEREncodePublicKey() encodes the subjectPublicKey part of subjectPublicKeyInfo, without the BIT STRING header.

See also
  DEREncodeAlgorithmParameters

Implements X509PublicKey.

## Validate()

bool RSAFunction::Validate | ( | RandomNumberGenerator & | rng,
|  | unsigned int | level
| ) |  | const

virtual

Check this object for errors.

Parameters

  rng | a RandomNumberGenerator for objects which use randomized testing
  level | the level of thoroughness

Returns
  true if the tests succeed, false otherwise

There are four levels of thoroughness:

- 0 - using this object won't cause a crash or exception
- 1 - this object will probably function, and encrypt, sign, other operations correctly
- 2 - ensure this object will function correctly, and perform reasonable security checks
- 3 - perform reasonable security checks, and do checks that may take a long time

Level 0 does not require a RandomNumberGenerator. A NullRNG() can be used for level 0. Level 1 may not check for weak keys and such. Levels 2 and 3 are recommended.

See also
  ThrowIfInvalid()

Implements CryptoMaterial.

## GetVoidValue()

bool RSAFunction::GetVoidValue | ( | const char * | name,
|  | const std::type_info & | valueType,
|  | void * | pValue
| ) |  | const

virtual

Get a named value.

Parameters

  name | the name of the object or value to retrieve
  valueType | reference to a variable that receives the value
  pValue | void pointer to a variable that receives the value

Returns
  true if the value was retrieved, false otherwise

GetVoidValue() retrieves the value of name if it exists.

Note
  GetVoidValue() is an internal function and should be implemented by derived classes. Users should use one of the other functions instead.

See also
  GetValue(), GetValueWithDefault(), GetIntValue(), GetIntValueWithDefault(), GetRequiredParameter() and GetRequiredIntParameter()

Implements NameValuePairs.

## AssignFrom()

void RSAFunction::AssignFrom | ( | const NameValuePairs & | source | ) |

virtual

Assign values to this object.

This function can be used to create a public key from a private key.

Implements CryptoMaterial.

## ApplyFunction()

Integer RSAFunction::ApplyFunction | ( | const Integer & | x | ) | const

virtual

Applies the trapdoor.

Parameters

  x | the message on which the encryption function is applied

Returns
  the message x encrypted under the public key

ApplyFunction is a generalization of encryption under a public key cryptosystem. Derived classes must implement it.

Implements TrapdoorFunction.

Reimplemented in RSAFunction_ISO.

## PreimageBound()

Integer RSAFunction::PreimageBound | ( |  | ) | const

inline virtual

Returns the maximum size of a message before the trapdoor function is applied.

Returns
  the maximum size of a message before the trapdoor function is applied

Derived classes must implement PreimageBound().

Implements TrapdoorFunctionBounds.

Reimplemented in RSAFunction_ISO.

Definition at line 46 of file rsa.h.

## ImageBound()

Integer RSAFunction::ImageBound | ( |  | ) | const

inline virtual

Returns the maximum size of a representation after the trapdoor function is applied.

Returns
  the maximum size of a representation after the trapdoor function is applied

Derived classes must implement ImageBound().

Implements TrapdoorFunctionBounds.

Definition at line 47 of file rsa.h.

## GetModulus()

const Integer & RSAFunction::GetModulus | ( |  | ) | const

inline

Definition at line 50 of file rsa.h.

## GetPublicExponent()

const Integer & RSAFunction::GetPublicExponent | ( |  | ) | const

inline

Definition at line 51 of file rsa.h.

## SetModulus()

void RSAFunction::SetModulus | ( | const Integer & | n | ) |

inline

Definition at line 53 of file rsa.h.

## SetPublicExponent()

void RSAFunction::SetPublicExponent | ( | const Integer & | e | ) |

inline

Definition at line 54 of file rsa.h.

The documentation for this class was generated from the following file:

- rsa.h